Call dm_put_target_type() *after* calling the destructor.
--- diff/drivers/md/dm-table.c	2003-06-17 10:05:53.000000000 +0100
+++ source/drivers/md/dm-table.c	2003-06-17 10:06:22.000000000 +0100
@@ -207,12 +207,12 @@
 
 	/* free the targets */
 	for (i = 0; i < t->num_targets; i++) {
-		struct dm_target *tgt = &t->targets[i];
-
-		dm_put_target_type(t->targets[i].type);
+		struct dm_target *tgt = t->targets + i;
 
 		if (tgt->type->dtr)
 			tgt->type->dtr(tgt);
+
+		dm_put_target_type(tgt->type);
 	}
 
 	vfree(t->highs);
